
	section .text
	align 1


	global _abs                ; short abs(short)
_abs
	ted
	bpl  L1
	negd
L1
	rts


	global _labs               ; long labs(long)
_labs
	tste
	bmi  _lneg
	rts


	global _lneg               ; long lneg(long)
_lneg
	comd       ; complement
	come
	addd #1    ; add 1
	adce #0
	rts

	global _lnegate            ; void lnegate(long *)
_lnegate
	xgex
	lde  0,x
	ldd  2,x
	bsr  _lneg
	ste  0,x
	std  2,x
	rts


skip_another
	aix  #+1            ; assume no danger of passing bank edge
skip_leading
	cmpb 0,x
	beq  skip_another
	rts

	global _atow

_atow                   ; word atow(byte *)

	xgex                ; string pointer

	ldab # ' '
	bsr  skip_leading   ; blanks
	ldab # '0'
	bsr  skip_leading   ; and then zeroes

	clre                ; result zero
	clra                ; prepare for ABE
L2
	ldab 0,x
	subb # '0'
	cmpb # 9
	bhi  L3        ; not isdigit

	xgdy
	ted
	asle
	asle
	ade
	asle           ; *= 10
	xgdy
	ade            ; += c - '0'

	aix  #+1
	bra  L2
L3
	ted            ; return
	rts


	global _setjmp, _longjmp

_setjmp           ; small model assumed, K not saved

	tex           ; env[]

	pulm e,d      ; peek PK and PC (jsr offset not fixed)

	stz  0,x      ; iz    frame of caller
	sts  2,x      ; sp    bare stack with no pk:pc
	ste  4,x      ; pk
	std  6,x      ; pc    could be pc:pk, but it does not matter

	pshm e,d      ; put them back for the first return

	clrd          ; return (0);
	rts

_longjmp

	tex           ; env[]
	tdy           ; return value

	ldz  0,x      ; iz    frame
	lds  2,x      ; sp    stack changes, bare stack now
	lde  4,x      ; pk
	ldd  6,x      ; pc

	pshm e,d      ; return address to stack (with jsr offset)

	tyd           ; return (1);
	rts


	end
